﻿@page "/paper/pdfviewer/{PaperId:int}"
@using ProyectoFase2.Shared.General;
@using ProyectoFase2.Shared.Models.Paper;
@inject INotificationCustomerService NotificationService
@inject IHTTPClientRequestService Http
@inject IJSRuntime JSRuntime
@inject IToolTipCustomer tooltipService

@if (LoadingData)
{
    <RadzenCardLoader IsLoading="@LoadingData">
    </RadzenCardLoader>
}
else
{
    @if (ShowPDF && !string.IsNullOrEmpty(PDFFile))
    {
        <embed src="@PDFFile" visible="false" width="1500" height="2000" />
    }
}


@code
{
    public bool LoadingData { get; set; } = false;
    public bool ShowPDF { get; set; } = false;
    public string PDFFile { get; set; } = string.Empty;

    [Parameter]
    public int PaperId { get; set; }

    protected override async Task OnInitializedAsync()
    {
        try
        {
            LoadingData = true;
            await this.LoadData();
            LoadingData = false;
        }
        catch (Exception ex)
        {
            NotificationService.Notify(ex.Message, NotificationSeverity.Error);
        }
        finally
        {
            LoadingData = false;
        }
    }

    public async Task LoadData()
    {
        try
        {
            LoadingData = true;
            ShowPDF = false;
            NotificationService.Notify("Abriendo PDF...", NotificationSeverity.Info);
            var request = await Http.Get<FileInBytesDTO>($"api/Paper/File/{PaperId}");


            if (request.Succeeded)
            {
                if (request.Result != null)
                {
                    string base64ArchivoPDF = Convert.ToBase64String(request.Result.File);
                    PDFFile = "data:application/pdf;base64," + base64ArchivoPDF;
                    await JSRuntime.InvokeVoidAsync("descargarArchivo", base64ArchivoPDF, "file.pdf");
                    ShowPDF = true;
                }
                else
                {
                    NotificationService.Notify("Ocurrió un error cargando la información.", NotificationSeverity.Error);
                }
            }
            else
            {
                var error = request.ErrorMessage();
                NotificationService.Notify(error, NotificationSeverity.Error);
            }

            ShowPDF = true;
        }
        catch (Exception ex)
        {
            NotificationService.Notify(ex.Message, NotificationSeverity.Error);
        }
        finally
        {
            LoadingData = false;
        }
    }

    void ShowTooltip(ElementReference elementReference, string text)
    {
        tooltipService.ShowToolTip(elementReference, text);
    }
}
